//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//
// Random Sentence Generator template
//
// University of Delaware
// CISC181, spring, 2010
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#ifndef RSG_H
#define RSG_H

//----------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>

#include <math.h>
#include <sys/time.h>

#include <iostream>
#include <fstream>
#include <cstdlib>
#include <string>
#include <vector> 
#include <map>
#include <list>

using namespace std;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// char tokens

const char NONTERMINAL_START_CHAR  = '<';
const char NONTERMINAL_END_CHAR    = '>';

const char RULESET_START_CHAR      = '{';
const char RULESET_END_CHAR        = '}';

const char RULE_END_CHAR           = ';';

// string tokens (it may be more convenient to 
// compare to strings rather than chars sometimes)
 
const string RULESET_END_STRING    = "}";
const string RULE_END_STRING       = ";";

const string START_NONTERMINAL     = "<start>";

// typedefs -- note that Rules and Sentences are 
// the same--it's just about context

typedef list<string>               Rule;
typedef vector<Rule>               RuleSet;
typedef map<string, RuleSet>       Grammar;
typedef list<string>               Sentence;

//----------------------------------------------------------------------------

void init_random();
double uniform_random(double, double);
int uniform_random_int(int, int);

string Sentence2String(Sentence &);
void PrintRule(Rule &);
void PrintRuleSet(string &, RuleSet &);
void PrintGrammar(Grammar &);
bool IsNonTerminal(string &);
void CreateSampleGrammar(Grammar &);

bool ParseGrammar(string, Grammar &);
void ExpandRandomly(Grammar &, Sentence &);

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#endif
