//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//
// Random Sentence Generator template
//
// University of Delaware
// CISC181, spring, 2010
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#include "RSG.hh"

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// take a filename as a C++ string, open it, and read in RuleSets one by one.
// concatenated together in vector, these form a Grammar.

// any text in between RuleSets (i.e., outside of a { } block) should be ignored.

// make sure to check for errors--if you find any, return false.
// otherwise return true at the end of the function

bool ParseGrammar(string g_filename, Grammar & G)
{
  return false;
}

//----------------------------------------------------------------------------

// given a grammar (assumed to contain one RuleSet for <start>),
// create a sentence which contains only <start> to begin with, 
// replace it with a randomly chosen rule from its rule set, and continue
// until there are no more non-terminals to expand.  at this point
// the sentence is all non-terminals, and it can be printed by the 
// calling function.

void ExpandRandomly(Grammar & G, Sentence & S)
{

}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

int main(int argc, char** argv)
{
  // argument should be .g file

  if (argc < 2) {
    cout << "Please specify .g grammar file or -sample\n";
    exit(1);
  }

  Grammar G;
  string g_filename(argv[1]);

  // parse grammar file?

  if (g_filename != "-sample") {

    bool result = ParseGrammar(g_filename, G);
    
    if (!result) {
      cout << "No grammar read\n";
      exit(1);
    }
  }

  // or create "hard-coded" grammar?

  else 
    CreateSampleGrammar(G);

  // show what's been read in

  PrintGrammar(G);

  // generate and print sentences until user says to quit 

  char c;
  Sentence S;

  init_random();

  do {

    ExpandRandomly(G, S);

    cout << "--------------------------------------------------------------------------\n";
    cout << Sentence2String(S) << endl;
    cout << "--------------------------------------------------------------------------\n";

    cout << "Another? (y/n) ";
    cin >> c;

  } while (c == 'y');


  return 1;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
